package cn.wisenergy.chnmuseum.party.service;

import cn.wisenergy.chnmuseum.party.model.Asset;
import cn.wisenergy.chnmuseum.party.model.TBoxOperation;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * 视频 服务类
 * </p>
 *
 * @author Danny Lee
 * @since 2021-03-16
 */
public interface AssetService extends IService<Asset> {

    Page<Asset> pageByConditions(Page<Object> page, String videoContentCatId, String videoContentCopyrightOwnerId);

    List<TBoxOperation> listBoxByOrgan();

}
